DESCRIPTION = "Example application"
LICENSE = "BSD-3-Clause"
LIC_FILES_CHKSUM = "file://${COREBASE}/meta/files/common-licenses/BSD-3-Clause;md5=550794465ba0ec5312d6919e203a55f9"

inherit pkgconfig
inherit systemd

SYSTEMD_AUTO_ENABLE = "enable"
SYSTEMD_SERVICE_${PN} = "somlabs-example.service"

SRC_URI = " \
    file://main.c \
    file://somlabs-example.service \
    "

S = "${WORKDIR}"

do_compile() {
    ${CC} ${CFLAGS} ${LDFLAGS} main.c -o somlabs-example
}

do_install() {
    install -d ${D}/usr/share/somlabs-example/
    install -m 0755 somlabs-example ${D}/usr/share/somlabs-example/

    install -d ${D}/${systemd_unitdir}/system
    install -m 0644 ${WORKDIR}/somlabs-example.service ${D}/${systemd_unitdir}/system
}

FILES_${PN} = " /usr/share/somlabs-example/ ${systemd_unitdir}/system/somlabs-example.service"

