from flask import Flask
from flask import send_from_directory
from flask import render_template 
from flask import request 

app = Flask(__name__, template_folder='/usr/share/somlabs-web')

@app.route('/favicon.ico')
def favicon():
    return send_from_directory('/usr/share/apache2/default-site/htdocs/manual/images/',
                               'favicon.ico', mimetype='image/vnd.microsoft.icon')

def get_led(led_path):
    f = open(led_path, 'r')
    state = f.read()[0]
    f.close()
    return state

def set_led(led_path, enabled):
    f = open(led_path, 'w')
    f.write('{}'.format('1' if enabled else '0'))
    f.close()


@app.route('/', methods=['GET', 'POST'])
def leds():
    if request.method == "POST":
        set_led('/sys/class/leds/LED-IO-04/brightness', request.form.get('led1')=='on')
        set_led('/sys/class/leds/LED-IO-05/brightness', request.form.get('led2')=='on')
        set_led('/sys/class/leds/LED-IO-06/brightness', request.form.get('led3')=='on')
        set_led('/sys/class/leds/LED-IO-07/brightness', request.form.get('led4')=='on')

    led1_state = get_led('/sys/class/leds/LED-IO-04/brightness')
    led2_state = get_led('/sys/class/leds/LED-IO-05/brightness')
    led3_state = get_led('/sys/class/leds/LED-IO-06/brightness')
    led4_state = get_led('/sys/class/leds/LED-IO-07/brightness')

    return render_template('templates/leds.html',
                           led1='checked' if led1_state=='1' else '',
                           led2='checked' if led2_state=='1' else '',
                           led3='checked' if led3_state=='1' else '',
                           led4='checked' if led4_state=='1' else '')
