from flask import Flask
from flask import send_from_directory
from flask import render_template
from flask import Response 
import struct

app = Flask(__name__, template_folder='/usr/share/somlabs-web')

@app.route('/favicon.ico')
def favicon():
    return send_from_directory('/usr/share/apache2/default-site/htdocs/manual/images/',
                               'favicon.ico', mimetype='image/vnd.microsoft.icon')

def get_message():
    f = open( "/dev/input/event0", "rb" );
    while 1:
        event_data = struct.unpack('4IHHI', f.read(24))
        if event_data[4]==1:
            f.close()
            if event_data[6]==0:
                return ""
            if event_data[5]==259:
                return "IO3"
            if event_data[5]==258:
                return "IO2"
            if event_data[5]==257:
                return "IO1"
            if event_data[5]==256:
                return "IO0"

@app.route('/stream')
def stream():
    def eventStream():
        while True:
            yield 'data: {}\n\n'.format(get_message())
    return Response(eventStream(), mimetype="text/event-stream")

@app.route('/')
def buttons():
    return render_template('templates/buttons.html')

